{-|
Module      : OpenAlex.ServantClientLogging
Description : Textmining Collaborative Platform
Copyright   : (c) CNRS, 2023-Present
License     : AGPL + CECILL v3
Maintainer  : team@gargantext.org
Stability   : experimental
Portability : POSIX

@Gargantext@: search, map, share
-}


module OpenAlex.ServantClientLogging where

import Data.Binary.Builder qualified as DBB
import Debug.Trace (trace)
import Protolude hiding (trace)
import Servant.Client (ClientEnv(..))
import Servant.Client.Core.Request (RequestF(..))


addLoggingToClientEnv :: ClientEnv -> ClientEnv
addLoggingToClientEnv env@(ClientEnv { makeClientRequest = mcr }) = env { makeClientRequest }
  where
    makeClientRequest baseUrl req =
      trace ("req: " <> showRequestPath req <> " " <> show (requestQueryString req)) $ mcr baseUrl req
    showRequestPath req =
      show $ DBB.toLazyByteString $ requestPath req



